
Foreman - Bug #16389

Can't create taxable e.g. domain object if I'm in context of specific organization or location

08/31/2016 04:36 AM - Marek Hulán

Status: Closed   

Priority: Normal   

Assignee: Marek Hulán   

Category: Organizations and Locations   

Target version: 1.12.3   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/3801

  

Description

Steps to reproduce:

1) make sure you have organization, e.g. org A

2) switch to org A in context selector

3) go to domain

4) create a domain assigned to org A, this might still work

5) try to create new one again assigned to org A (should be preselected since you're in its context), it will stuck on the creation form

displaying no errors and you can find "Failed to save: Taxable taxonomies is invalid" in log (if you have at least info level enabled)

to reproduce from console

# make sure there's at least one Domain in Organization.first

Organization.current = Organization.first

d = Domain.new :organization_ids => [1]

d.valid? # => false

d.taxable_taxonomies # return invalid taxable taxonomies linked to other (existing!) domain

 Cause:

It seems that default scope added by taxonomies registers ids of existing records which gets picked by 

https://github.com/rails/rails/blob/v4.2.7.1/activerecord/lib/active_record/scoping/named.rb#L39:AR when it creates associations. A

workaround is to do Domain.unscoped.new

Related issues:

Related to OpenSCAP - Bug #16229: Invalid Taxable taxonomies when creating po... Closed 08/22/2016

Related to Foreman - Tracker #10022: Taxonomies related issues New 04/05/2015

Related to Foreman - Bug #4731: Creating domain when organization selected pr... Closed 03/19/2014

Related to Foreman - Bug #16463: with_taxonomy_scope returns all objects when... Closed 09/07/2016

Has duplicate Foreman - Bug #16471: Cannot create Host Group: Taxable taxonom... Duplicate 09/07/2016

Associated revisions

Revision 35ed04f9 - 09/02/2016 11:29 AM - Marek Hulán

Fixes #16389 - enable taxable object creation in specific context

Revision e0b91994 - 09/19/2016 11:59 AM - Marek Hulán

Fixes #16389 - enable taxable object creation in specific context

(cherry picked from commit 35ed04f95f14c934ffebc874e90a3a4a6684fe71)

History

#1 - 08/31/2016 04:36 AM - Marek Hulán

- Related to Bug #16229: Invalid Taxable taxonomies when creating policy through UI added
https://github.com/rails/rails/blob/v4.2.7.1/activerecord/lib/active_record/scoping/named.rb#L39:AR


#2 - 08/31/2016 04:37 AM - Marek Hulán

- Related to Tracker #10022: Taxonomies related issues added

#3 - 08/31/2016 05:25 AM - Marek Hulán

- Related to Bug #4731: Creating domain when organization selected produces duplicate key error added

#4 - 08/31/2016 07:41 AM - Marek Hulán

- Status changed from New to Assigned

- Assignee set to Marek Hulán

#5 - 08/31/2016 11:37 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3801 added

#6 - 08/31/2016 11:37 AM - Marek Hulán

A proper fix should probably go to rails - https://github.com/rails/rails/pull/26342 but it's unrealistic to expect having this available anytime soon.

Meanwhile, we can expand our existing hack to workaround it.

#7 - 09/01/2016 05:32 AM - Marek Hulán

Since the upstream fix was declined, we have to solve it in Foreman. Probably less hacky way is to generate the part of SQL as a string so AREL

can't parse it and register the condition for new instance, e.g.

Domain.where(id: 1).new.id # => 1

Domain.where('id IN (1)').new.id # => nil

#8 - 09/02/2016 12:02 PM - Marek Hulán

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 35ed04f95f14c934ffebc874e90a3a4a6684fe71.

#9 - 09/05/2016 04:05 AM - Dominic Cleal

- translation missing: en.field_release set to 181

#10 - 09/06/2016 10:54 AM - Marek Hulán

- Target version set to 1.6.0

#11 - 09/07/2016 08:08 AM - Dominic Cleal

- Related to Bug #16463: with_taxonomy_scope returns all objects when no taxable ids available added

#12 - 09/07/2016 11:21 AM - Dominic Cleal

- Has duplicate Bug #16471: Cannot create Host Group: Taxable taxonomies is invalid added
